--the ncurses wrapper


include wrapper.ew
include misc.e

global object VOID


global atom ncurses_so, panel_so, menu_so, form_so
if platform() = LINUX then
        --ncurses_so = link_dll("libncurses.so")
        ncurses_so = link_dll("")
	panel_so = link_dll("libpanel.so")
        menu_so = link_dll("libmenu.so")
        form_so = link_dll("libform.so")
else
        puts(1, "This is a linux only lib")
        abort (0)
end if

--this is the predifined window for ncurses
global integer stdscr   
stdscr = peek4u(define_c_var(ncurses_so, "stdscr"))

global constant NCURSES_ATTR_SHIFT = 8

--name changed to avoid name space clashes, thanks to Greg Haberek for this
function NC_shift_left( atom x, integer bits )
    return x * power( 2, bits )
end function

-- #define NCURSES_BITS(mask,shift)     ((mask)<<((shift)+8))
global function NCURSES_BITS( integer mask, integer shift )
    return NC_shift_left( mask, shift + NCURSES_ATTR_SHIFT )
end function

global constant
-- #define A_COLOR      NCURSES_BITS(((1UL)<<8)-1UL,0)
A_COLOR = NCURSES_BITS( NC_shift_left(1, 8) - 1, 0),
-- #define A_CHARTEXT   (NCURSES_BITS(1UL,0)-1UL)
A_CHARTEXT = NCURSES_BITS(1, 0) - 1,
-- #define A_NORMAL     0L
A_NORMAL = 0,
-- #define A_REVERSE    NCURSES_BITS(1UL,10)
A_REVERSE = NCURSES_BITS(1, 10),
-- #define A_BLINK      NCURSES_BITS(1UL,11)
A_BLINK = NCURSES_BITS(1, 11),
-- #define A_DIM        NCURSES_BITS(1UL,12),
A_DIM = NCURSES_BITS(1,12),
-- #define A_BOLD       NCURSES_BITS(1UL,13)
A_BOLD = NCURSES_BITS(1,13),
-- #define A_ALTCHARSET NCURSES_BITS(1UL,14)
A_ALTCHARSET = NCURSES_BITS(1,14),
-- #define A_INVIS      NCURSES_BITS(1UL,15)
A_INVIS = NCURSES_BITS(1,15),
-- #define A_PROTECT    NCURSES_BITS(1UL,16)
A_PROTECT =     NCURSES_BITS(1,16),
-- #define A_HORIZONTAL NCURSES_BITS(1UL,17)
A_HORIZONTAL  = NCURSES_BITS(1,17),
-- #define A_LEFT       NCURSES_BITS(1UL,18)
A_LEFT    =   NCURSES_BITS(1,18),
-- #define A_LOW        NCURSES_BITS(1UL,19)
A_LOW =       NCURSES_BITS(1,19),
-- #define A_RIGHT      NCURSES_BITS(1UL,20)
A_RIGHT   =   NCURSES_BITS(1,20),
-- #define A_TOP        NCURSES_BITS(1UL,21)
A_TOP  =      NCURSES_BITS(1,21),
-- #define A_VERTICAL   NCURSES_BITS(1UL,22)
A_VERTICAL  = NCURSES_BITS(1,22),
-- #define A_STANDOUT   NCURSES_BITS(1UL,8)
A_STANDOUT  = NCURSES_BITS(1,8),
-- #define A_UNDERLINE  NCURSES_BITS(1UL,9)
A_UNDERLINE =  NCURSES_BITS(1,9),
-- #define A_ATTRIBUTES NCURSES_BITS(~(1UL-1UL),0)
-- ~ is ones complement, or not
A_ATTRIBUTES = NCURSES_BITS(not_bits(1-1),0)



-- these should already be defined, so just have to find them


-- 
-- 
-- 
-- #define WA_ALTCHARSET        A_ALTCHARSET
-- #define WA_ATTRIBUTES        A_ATTRIBUTES
-- #define WA_BLINK     A_BLINK
-- #define WA_BOLD      A_BOLD
-- #define WA_DIM       A_DIM
-- #define WA_HORIZONTAL        A_HORIZONTAL
-- #define WA_INVIS     A_INVIS
-- #define WA_LEFT      A_LEFT
-- #define WA_LOW       A_LOW
-- #define WA_NORMAL    A_NORMAL
-- #define WA_PROTECT   A_PROTECT
-- #define WA_REVERSE   A_REVERSE
-- #define WA_RIGHT     A_RIGHT
-- #define WA_STANDOUT  A_STANDOUT
-- #define WA_TOP       A_TOP
-- #define WA_UNDERLINE A_UNDERLINE
-- #define WA_VERTICAL  A_VERTICAL
-- 
-- 
-- 
-- #define COLOR_BLACK  0
-- #define COLOR_RED    1
-- #define COLOR_GREEN  2
-- #define COLOR_YELLOW 3
-- #define COLOR_BLUE   4
-- #define COLOR_MAGENTA        5
-- #define COLOR_CYAN   6
-- #define COLOR_WHITE  7
-- 
-- 
-- 
-- #define _SUBWIN      0x01
-- #define _ENDLINE     0x02
-- #define _FULLWIN     0x04
-- #define _ISPAD       0x10
-- #define _HASMOVED    0x20
-- #define TRACE_MAXIMUM        0xffff
-- 
-- 
-- 
-- 
-- 
-- typedef unsigned long chtype;
-- typedef char bool;
-- typedef struct screen SCREEN;
-- typedef struct _win_st WINDOW;
-- typedef chtype attr_t;
-- typedef struct
-- {
--   attr_t attr;
--   wchar_t chars[5];
-- }
-- cchar_t;
-- struct pdat
-- {
--   short _pad_y;
--   short _pad_x;
--   short _pad_top;
--   short _pad_left;
--   short _pad_bottom;
--   short _pad_right;
-- }
--  ;
-- 
-- 
-- struct _win_st
-- {
--   short _cury;
--   short _curx;
--   short _maxy;
--   short _maxx;
--   short _begy;
--   short _begx;
--   short _flags;
--   attr_t _attrs;
--   chtype _bkgd;
--   bool _notimeout;
--   bool _clear;
--   bool _leaveok;
--   bool _scroll;
--   bool _idlok;
--   bool _idcok;
--   bool _immed;
--   bool _sync;
--   bool _use_keypad;
--   int _delay;
--   struct ldat *_line;
--   short _regtop;
--   short _regbottom;
--   int _parx;
--   int _pary;
--   WINDOW *_parent;
--   struct pdat _pad;
--   short _yoffset;
--   cchar_t _bkgrnd;
-- }
--  ;

global constant
KEY_CODE_YES    = 0400,
KEY_BREAK       = 0401,
KEY_MIN         = 0401,
KEY_DOWN        = 0402,
KEY_UP          = 0403,
KEY_LEFT        = 0404,
KEY_RIGHT       = 0405,
KEY_HOME        = 0406,
KEY_BACKSPACE   = 0407,
KEY_F0          = 0410,
KEY_DL          = 0510,
KEY_IL          = 0511,
KEY_DC          = 0512,
KEY_IC          = 0513,
KEY_EIC         = 0514,
KEY_CLEAR       = 0515,
KEY_EOS         = 0516,
KEY_EOL         = 0517,
KEY_SF          = 0520,
KEY_SR          = 0521,
KEY_NPAGE       = 0522,
KEY_PPAGE       = 0523,
KEY_STAB        = 0524,
KEY_CTAB        = 0525,
KEY_CATAB       = 0526,
KEY_ENTER       = 0527,
KEY_SRESET      = 0530,
KEY_RESET       = 0531,
KEY_PRINT       = 0532,
KEY_LL          = 0533,
KEY_A1          = 0534,
KEY_A3          = 0535,
KEY_B2          = 0536,
KEY_C1          = 0537,
KEY_C3          = 0540,
KEY_BTAB        = 0541,
KEY_BEG         = 0542,
KEY_CANCEL      = 0543,
KEY_CLOSE       = 0544,
KEY_COMMAND     = 0545,
KEY_COPY        = 0546,
KEY_CREATE      = 0547,
KEY_END         = 0550,
KEY_EXIT        = 0551,
KEY_FIND        = 0552,
KEY_HELP        = 0553,
KEY_MARK        = 0554,
KEY_MESSAGE     = 0555,
KEY_MOVE        = 0556,
KEY_NEXT        = 0557,
KEY_OPEN        = 0560,
KEY_OPTIONS     = 0561,
KEY_PREVIOUS    = 0562,
KEY_REDO        = 0563,
KEY_REFERENCE   = 0564,
KEY_REFRESH     = 0565,
KEY_REPLACE     = 0566,
KEY_RESTART     = 0567,
KEY_RESUME      = 0570,
KEY_SAVE        = 0571,
KEY_SBEG        = 0572,
KEY_SCANCEL     = 0573,
KEY_SCOMMAND    = 0574,
KEY_SCOPY       = 0575,
KEY_SCREATE     = 0576,
KEY_SDC         = 0577,
KEY_SDL         = 0600,
KEY_SELECT      = 0601,
KEY_SEND        = 0602,
KEY_SEOL        = 0603,
KEY_SEXIT       = 0604,
KEY_SFIND       = 0605,
KEY_SHELP       = 0606,
KEY_SHOME       = 0607,
KEY_SIC         = 0610,
KEY_SLEFT       = 0611,
KEY_SMESSAGE    = 0612,
KEY_SMOVE       = 0613,
KEY_SNEXT       = 0614,
KEY_SOPTIONS    = 0615,
KEY_SPREVIOUS   = 0616,
KEY_SPRINT      = 0617,
KEY_SREDO       = 0620,
KEY_SREPLACE    = 0621,
KEY_SRIGHT      = 0622,
KEY_SRSUME      = 0623,
KEY_SSAVE       = 0624,
KEY_SSUSPEND    = 0625,
KEY_SUNDO       = 0626,
KEY_SUSPEND     = 0627,
KEY_UNDO        = 0630,
KEY_MOUSE       = 0631,
KEY_RESIZE      = 0632,
KEY_MAX         = 0777



-------------------------------------------------------------------------------
--initialise ncurses
integer xinitscr
xinitscr = link_func(ncurses_so, "initscr", {}, C_INT)
global function initscr()
-------------------------------------------------------------------------------
atom pointer        
        pointer = c_func(xinitscr, {})
return pointer
end function


-------------------------------------------------------------------------------
--ends ncurses, returns to cooked mode
integer xendwin
xendwin = link_proc(ncurses_so, "endwin", {})
global procedure endwin()
-------------------------------------------------------------------------------
        c_proc(xendwin, {})
end procedure

-------------------------------------------------------------------------------
--no new line
integer xnonl
xnonl = link_proc(ncurses_so, "nonl", {})
global procedure nonl()
-------------------------------------------------------------------------------
        c_proc(xnonl, {})
end procedure

-------------------------------------------------------------------------------
--no new line
integer xnl
xnl = link_proc(ncurses_so, "nl", {})
global procedure nl()
-------------------------------------------------------------------------------
        c_proc(xnl, {})
end procedure

-------------------------------------------------------------------------------
--cbreak
integer xcbreak
xcbreak = link_proc(ncurses_so, "cbreak", {})
global procedure cbreak()
-------------------------------------------------------------------------------
        c_proc(xcbreak, {})
end procedure

-------------------------------------------------------------------------------
--nocbreak
integer xnocbreak
xnocbreak = link_proc(ncurses_so, "nocbreak", {})
global procedure nocbreak()
-------------------------------------------------------------------------------
        c_proc(xnocbreak, {})
end procedure


-------------------------------------------------------------------------------
--noecho
integer xnoecho
xnoecho = link_proc(ncurses_so, "noecho", {})
global procedure noecho()
-------------------------------------------------------------------------------
        c_proc(xnoecho, {})
end procedure

-------------------------------------------------------------------------------
--echo
integer xecho
xecho = link_proc(ncurses_so, "echo", {})
global procedure echo()
-------------------------------------------------------------------------------
        c_proc(xecho, {})
end procedure

-------------------------------------------------------------------------------
--newwin
integer xnewwin
xnewwin = link_func(ncurses_so, "newwin", {C_INT,C_INT, C_INT, C_INT}, C_POINTER)
global function newwin(integer ncols, integer nlines, integer begin_y, integer begin_x)
-------------------------------------------------------------------------------
atom handle
        handle = c_func(xnewwin, {ncols, nlines, begin_y, begin_x})
return handle
end function

-------------------------------------------------------------------------------
--delwin
integer xdelwin
xdelwin = link_proc(ncurses_so, "delwin", {C_POINTER})
global procedure delwin(atom handle)
-------------------------------------------------------------------------------
        c_proc(xdelwin, {handle})
end procedure

-------------------------------------------------------------------------------
--waddch
integer xwaddch
xwaddch = link_proc(ncurses_so, "waddch", {C_POINTER, C_INT})
global procedure waddch(atom handle, integer ch)
-------------------------------------------------------------------------------
        c_proc(xwaddch, {handle, ch})
end procedure

-------------------------------------------------------------------------------
--mvwaddch
integer xmvwaddch
xmvwaddch = link_proc(ncurses_so, "mvwaddch", {C_POINTER, C_INT, C_INT, C_INT})
global procedure mvwaddch(atom handle, integer y, integer x, integer ch)
-------------------------------------------------------------------------------
        c_proc(xmvwaddch, {handle, x, y, ch})
end procedure

-------------------------------------------------------------------------------
--wrefresh
integer xwrefresh
xwrefresh = link_proc(ncurses_so, "wrefresh", {C_POINTER})
global procedure wrefresh(atom handle)
-------------------------------------------------------------------------------
        c_proc(xwrefresh, {handle})
end procedure

--------------------------------------------------------------------------------
--wgetch
integer xwgetch
xwgetch = link_func(ncurses_so, "wgetch", {C_POINTER}, C_INT)
global function wgetch(atom handle)
--------------------------------------------------------------------------------
integer ch
        ch = c_func(xwgetch, {handle} )
return ch
end function

--------------------------------------------------------------------------------
--int wborder(WINDOW *win, chtype ls, chtype rs,
          --chtype ts, chtype bs, chtype tl, chtype tr,
          --chtype bl, chtype br);
integer xwborder
xwborder = link_proc(ncurses_so, "wborder", {C_POINTER, C_INT, C_INT, C_INT, C_INT, C_INT, C_INT, C_INT, C_INT} )
global procedure wborder(atom handle, integer ls, integer rs, 
                        integer ts, integer bs, integer tl, integer tr, 
                        integer bl, integer br)
--------------------------------------------------------------------------------
        c_proc(xwborder, {handle, ls, rs, ts, bs, tl, tr, bl, br} )
end procedure

--------------------------------------------------------------------------------
--box
integer xbox --(!)
xbox = link_proc(ncurses_so, "box", {C_POINTER, C_INT, C_INT})
global procedure box(atom handle, integer verch, integer horch)
--------------------------------------------------------------------------------
        c_proc(xbox, {handle, verch, horch})
end procedure


